#include <stdio.h>
#include <stdlib.h>
#include <iostream.h>
#include "environ.h"
#include <string.h>
#include "cgiform.h"


EnvVars::EnvVars() : content_length(contentlen())
{

	server_software = getenv("SERVER_SOFTWARE");
	server_name = getenv("SERVER_NAME");
	gateway_interface = getenv("GATEWAY_INTERFACE");
	server_protocol = getenv("SERVER_PROTOCOL");
	server_port = getenv("SERVER_PORT");
	request_method = getenv("REQUEST_METHOD");
	path_info = getenv("PATH_INFO");
	path_translated = getenv("PATH_TRANSLATED");
	script_name = getenv("SCRIPT_NAME");
	query_string = getenv("QUERY_STRING");
	remote_host = getenv("REMOTE_HOST");
	remote_addr = getenv("REMOTE_ADDR");
	remote_ident = getenv("REMOTE_IDENT");
	content_type = getenv("CONTENT_TYPE");
	http_accept = getenv("HTTP_ACCEPT");
	http_user_agent = getenv("HTTP_USER_AGENT");
	if (__strnicmp ( request_method, "get", 3) == 0)
		  method = _GET;
	 else if (__strnicmp ( request_method, "post", 4) == 0)
		  method = _POST;
	 else method = _METHOD_UNKNOWN;


}

void EnvVars::display() const
{
		cout
		  << "Server_Software = " << server_software << ENDL
		  << "Server_Name = " << server_name << ENDL
		  << "Server_Port = " << server_port <<  ENDL
		  << "Gatway_Interface = " << gateway_interface << ENDL
		  << "Server_protocol = " << server_protocol << ENDL
		  << "Request_Method = " << request_method << ENDL
		  << "Path Info = " << path_info << ENDL
		  << "Path Translated = " << path_translated << ENDL
		  << "Script_Name = " << script_name << ENDL
		  << "Content_Length = " << content_length << ENDL
		  << "Query_String = " << query_string << ENDL
		  << "Remote_host = "   << remote_host << ENDL
		  << "Remote_Addr = "  << remote_addr << ENDL
		  << "Remote_Ident = " << remote_ident << ENDL
		  << "Content_Type = " << content_type << ENDL
		  << "Content_Length = " << contentlength << ENDL
		  << "Http_Accept = " << http_accept << ENDL
		  << "Http_User_agent = " << http_user_agent << ENDL;

}

char const* EnvVars::env_var(int num) const
{
  char const *var = 0;

	  switch (num)
	  {
		 case  _SERVER_SOFTWARE:
				  var = server_software;
				  break;
		 case  _SERVER_NAME:
				  var = server_name;
				  break;
		 case  _SERVER_PORT:
				  var = server_port;
				  break;
		 case  _GATEWAY_INTERFACE:
				  var = gateway_interface;
				  break;
		 case  _SERVER_PROTOCOL:
				  var = server_protocol;
				  break;
		 case  _REQUEST_METHOD:
				  var = request_method;
				  break;
		 case  _PATH_INFO:
				  var = path_info;
				  break;
		 case  _PATH_TRANSLATED:
				  var = path_translated;
				  break;
		 case  _SCRIPT_NAME:
				  var = script_name;
				  break;
		 case  _QUERY_STRING:
				  var = query_string;
				  break;
		 case  _REMOTE_HOST:
				  var = remote_host;
				  break;
		 case  _REMOTE_ADDR:
				  var = remote_addr;
				  break;
		 case  _REMOTE_IDENT:
				  var = remote_ident;
				  break;
		 case  _CONTENT_TYPE:
				  var = content_type;
				  break;
		 case  _CONTENT_LENGTH:
				  var = contentlength;
				  break;
		 case	 _HTTP_ACCEPT:
				  var = http_accept;
				  break;
		 case  _HTTP_USER_AGENT:
				  var = http_user_agent;
				  break;
		 default:
			  return (0);
	  }

	  return (var);
}

