#include "html.h"
#include <iostream.h>
#include <stdio.h>
#include <stdarg.h>
#include "cgiform.h"
int HTML::FirstInstance = 0;


// HTML FUNCTIONS
char *tag[] = { "H1", "H2", "H3", "H4", "H5", "H6",
	"B", "I", "P", "BR" };

	// List Types
char *LTypes[] = { "OL", "UL", "DL" };
char *LMarkers[] = { "LI", "LI", "DD" };


HTML::HTML (const char *type)
{

  if(!FirstInstance)
  {
  	cout <<  "Content-type: " << type << "\n\n";
  
  }
  FirstInstance = 1;

}

void HTML::text_out(int tnum, char *text)
{

	cout << '<' << tag[tnum] << '>';
	cout << text;
	cout << "</" << tag[tnum] << '>';
	if(tnum > _H6) cout << ENDL;

}


// TABLE FUNCTIONS


void TABLE::row_out(int cols,...)
{
	va_list ap;
	va_start(ap, cols);

	tcols = cols;

	tdata = new char * [cols];


	for (int ptr_no=0; ptr_no < cols; ptr_no++)
	  {
		 tdata[ptr_no] =  va_arg(ap, char *);
	  }

	 va_end(ap);

	 _row_out();

    delete[] tdata;
}


void TABLE::_row_out()
{

		cout << '\n';

		if (!row_format)
			otag("TR");
		else
			cout << "<TR " << row_format << ">\n";

	  for (int i=0; i < tcols; i++)
	  {
			otag("TD");
			cout << tdata[i];
			ctag("TD");
			cout << '\n';
	  }
	  ctag("TR");
	
}
